/*
 * Copyright (C) 2003-2009 eXo Platform SAS.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

package org.chromattic.common.xml;

import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import org.xml.sax.ext.LexicalHandler;

/**
 * @author <a href="mailto:julien.viet@exoplatform.com">Julien Viet</a>
 * @version $Revision$
 */
public class DocumentEmitter extends XMLEmitter {

  /** . */
  private ElementEmitter documentEmitter;


  public DocumentEmitter(ContentHandler handler) {
    this(handler, null);
  }

  public DocumentEmitter(ContentHandler contentHandler, LexicalHandler lexicalHandler) {
    super(new Handler(contentHandler, lexicalHandler));

    //
    this.documentEmitter = null;
  }

  public ElementEmitter documentElement(String qName) throws SAXException {
    if (documentEmitter != null) {
      throw new IllegalStateException();
    }
    if (qName == null) {
      throw new NullPointerException();
    }
    documentEmitter = new ElementEmitter(handler, qName);
    emitChild(documentEmitter);
    return documentEmitter;
  }



}
